//+------------------------------------------------------------------+
//|                                                    belajarEA.mq5 |
//|                                                    hadiidalmakin |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "hadiidalmakin"
#property link      "http://www.mql5.com"
#property version   "1.00"
#include <GetIndicatorBuffers.mqh>
#include <Expert\Trailing\TrailingFixedPips.mqh>
#include <Expert\Money\MoneyFixedLot.mqh>
//--- Input for setting
input string EA_title  ="FistandFurrios";
int          Magic_no  =190213;
//---Array for indicator RSI
input int  RSI_Period=2;    //RSI period for signal
double     RSI[];           //array the indicator iRSI
int        RSI_handle;      //handle of indicator iRSI

//---Array for indicator ADX
input int  ADX_Period=2;    //ADX indicator
double     Main_Line[];     // array for MAIN_LINE of iADX
double     PlusDI_Line[];   // array for PLUSDI_LINE of iADX
double     MinusDI_Line[];  // array for MINUSDI_LINE of iADX
int        adx_handle;      // handle my ADX indicator
//--- Trailing methode
input int  Trailing_FixedPips_StopLevel  =30;  //Stop trailing in pips
input int  Trailing_FixedPips_ProfitLevel=50;  // Take Profit trailing level (in points) 
//--- stop loss
input int  Stop_loss                     =30;  //Manage Stop loss
//--- money for manage in trading
input double Money_FixLot_Percent        =10.0;        // Percent
input double Money_FixLot_Lots           =0.1;         // Fixed volume

//---mql5 structure for use
MqlTick current_price;                     //get current price
MqlTradeCheckResult Result_Trading_check;  //check result of trading
MqlTradeRequest Mrequest;                  //Sending trade request
MqlRates mrate[];                          // To be used to store the prices, volumes and spread of each bar
   
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- get indicator RSI
   RSI_handle=iRSI(NULL,0,RSI_Period,PRICE_CLOSE);
   
//--- report if there was an error of object creation
   if (RSI_handle<0)
      {
      printf("The creation of iRSI has failed: Runtime error =",GetLastError());
      //---force program termination
      return(-1);
      }
//--- get ADX indicator
   adx_handle=iADX(NULL,0,ADX_Period);
   return(0);
//--- report if there was an error object creation
   if (adx_handle<0)
      {
      printf("the creation of iADX has failed: Runtime error=", GetLastError());
      return(-1);
      } 
//--- Creation of trailing object
   CTrailingFixedPips *trailing=new CTrailingFixedPips;
   if(trailing==NULL)
     {
      //--- failed
      printf(__FUNCTION__+": error creating trailing");
      return(-5);
     }
//--- Add trailing to expert (will be deleted automatically))
     {
      //--- failed
      printf(__FUNCTION__+": error initializing trailing");
      return(-6);
     }
//--- Set trailing parameters
   trailing.StopLevel(Trailing_FixedPips_StopLevel);
   trailing.ProfitLevel(Trailing_FixedPips_ProfitLevel);
//--- Creation of money object
   CMoneyFixedLot *money=new CMoneyFixedLot;
   if(money==NULL)
     {
      //--- failed
      printf(__FUNCTION__+": error creating money");
      return(-7);
     }      
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- Deinitialization indicator
     IndicatorRelease(RSI_handle & adx_handle);
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---array setting RSI
   ArraySetAsSeries(RSI,true);
//---array setting ADX_LINE
   if(!GetADXBuffers(adx_handle,0,100,Main_Line,PlusDI_Line,MinusDI_Line,true)) return;
//---Declaration for buy/sell condition

   bool Open_Buy=false;  // we have no open buy position
   bool Open_Sell=false; // we have no open sell position
     if(PositionSelect(_Symbol)==true) //now we are opening position
       {
        if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
        {
        Open_Buy=true;   //We are Open Buy
        }
        else if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
        {
        Open_Sell=true;  //We are Open Sell
        }
       }
          
//---Buy condition
   bool Buy_condition=(RSI[1]<10 && RSI[0]>10) && (PlusDI_Line[0]>MinusDI_Line[0]);
//---Sell condition
   bool Sell_condition=(RSI[1]>80 && RSI[0]<80) && (MinusDI_Line[0]>PlusDI_Line[0]);
  }
//+------------------------------------------------------------------+
//| Trade function                                                   |
//+------------------------------------------------------------------+
void OnTrade()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Tester function                                                  |
//+------------------------------------------------------------------+
double OnTester()
  {
//---
   double ret=0.0;
//---

//---
   return(ret);
  }
//+------------------------------------------------------------------+
